import os
from psycopg2 import pool
from my_feed_parser.core_parser.connection_provider import ConnectionProvider

class LocalPostgresConnectionProvider(ConnectionProvider):
    def __init__(self, dsn: str = None):
        if dsn is None:
            dsn = os.getenv("LOCAL_POSTGRES_DSN", "postgresql://myuser:mypass@localhost:5432/mydb")
        self._pool = pool.SimpleConnectionPool(
            minconn=1,
            maxconn=10,
            dsn=dsn
        )

    def get_connection(self):
        return self._pool.getconn()

    def release_connection(self, conn):
        self._pool.putconn(conn)
