from .base_parser import NewsFeedParser
from typing import Dict

class KhanParser(NewsFeedParser):
    def extract_article_metadata(self, entry) -> Dict:
        """Extract common fields like published and category."""
        return {
            'title': self.cleanse_text(entry.get('title', 'No Title')),
            'link': entry.get('link', 'No Link'),
            'category': self.categories,
            'published': self.extract_published_from_link(entry.get('link', None))
        }
    
    def extract_published_from_link(self, link: str) -> str:
        import re
        if link is None:
            date_str = ""
        else:
            match = re.search(r'/article/(\d{12})', link)
            if match:
                date_str = match.group(1)  # e.g., 20250116
            else:
                date_str = ""
        return self.convert_to_isoformat(date_str)
